#pragma once
/*
     Malware.
*/

#include "crypt.h"

namespace MalwareTools
{
  //Flags format name.
  enum
  {
    NCF_ALL_LOWER    = 0x0, //All in lowercase.
    //NCF_ALL_UPPER = 0x1, yet do not need
    NCF_FIRST_UPPER  = 0x2, //The first character in verhenm register, the rest at the bottom.
    NCF_ALLOW_SPACES = 0x4 //Allow spaces.
  };

  //The scope of a kernel object.
  enum
  {
    KON_DEFAULT, //By default, no prefix.
    KON_SESSION, //Within the current session, the prefix Local.
    KON_GLOBAL,  //Global, prefix Global.
  };
  
  /*
    .
  */
  void init(void);

  /*
    .
  */
  void uninit(void);

  /*
     .

    IN dwCaseFlags -  NCF_*.
    OUT pstrName   -   .
    IN bMinChars   -     .
    IN bMaxChars   -     .
  */
  void _GenerateRandomNameW(DWORD dwCaseFlags, LPWSTR pstrName, BYTE bMinChars, BYTE bMaxChars);
  void _GenerateRandomNameA(DWORD dwCaseFlags, LPSTR pstrName, BYTE bMinChars, BYTE bMaxChars);

  /*
      _GenerateRandomNameW,        .

    IN dwCaseFlags   -  NCF_*.
    IN pstrPath      -   .
    OUT pstrName     -   ,       MAX_PATH  
                         .
    IN pstrExtension -  ,  NULL.
    IN bMinChars     -     .
    IN bMaxChars     -     .

    Return           - true -   ,
                       false -   .
  */
  bool _GenerateRandomFileName(DWORD dwCaseFlags, LPWSTR pstrPath, LPWSTR pstrName, LPWSTR pstrExtension, BYTE bMinChars, BYTE bMaxChars);

  
  /*
      _GenerateRandomNameW,        .

    IN dwCaseFlags -  NCF_*.
    IN hRoot       -   .
    IN pstrPath    -   .
    OUT pstrName   -    pstrPath.
    IN bMinChars   -     .
    IN bMaxChars   -     .

    Return         - true -   ,
                     false -   .
  */
  bool _GenerateRandomRegKeyName(DWORD dwCaseFlags, HKEY hRoot, LPWSTR pstrPath, LPWSTR pstrName, BYTE bMinChars, BYTE bMaxChars);
  
  /*
      ID .

    OUT guid - ID .

    Return   - true -   ,
               false -    (pGUID   ).
  */
  bool _getOsGuid(GUID *guid);

  /*    Generating a unique name for the kernel object in the form of GUID.

    IN osGuid - result _getOsGuid ().
    IN advId1 - additional indefikator 1.
    IN advId2 - additional indefikator 2.
    OUT buffer - a buffer for "CLSID", at least 40 characters. And if (asLocal == true), then 50.
    IN rc4Key - key to encrypt (unchanged), or NULL.
    IN objectNamespace - visibility element KON_ *.
  */
  void _generateKernelObjectName(GUID *osGuid, DWORD advId1, DWORD advId2, LPWSTR buffer, Crypt::RC4KEY *rc4Key, BYTE objectNamespace);
};
